ome-xml 5.2.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions | Private Attributes | List of all members
ome::xml::model::Experiment Class Reference

Experiment model object. More...

`#include <ome/xml/model/Experiment.h>`

Inheritance diagram for ome::xml::model::Experiment:
[legend]
Collaboration diagram for ome::xml::model::Experiment:
[legend]

## Classes
class | Impl
| Private implementation details of Experiment model object. More...

## Public Member Functions
| Experiment ()
| Default constructor.
| Experiment (const Experiment &copy)
| Copy constructor. More...
virtual | ~Experiment ()
| Destructor.
const std::string & | elementName () const
| Get the element name of this model object. More...
bool | validElementName (const std::string &name) const
| Check if a given element name is valid for processing by this model object. More...
virtual void | update (const common::xml::dom::Element &element, ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > | getType ()
| Get the Type property. More...
const ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > | getType () const
| Get the Type property. More...
void | setType (ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > &type)
| Set the Type property. More...
const std::string & | getID () const
| Get the ID property. More...
void | setID (const std::string &id)
| Set the ID property. More...
ome::compat::shared_ptr< std::string > | getDescription ()
| Get the Description property. More...
const ome::compat::shared_ptr< std::string > | getDescription () const
| Get the Description property. More...
void | setDescription (ome::compat::shared_ptr< std::string > &description)
| Set the Description property. More...
ome::compat::weak_ptr< ome::xml::model::Experimenter > | getLinkedExperimenter ()
| Get linked Experimenter. More...
const ome::compat::weak_ptr< ome::xml::model::Experimenter > | getLinkedExperimenter () const
| Get linked Experimenter. More...
void | linkExperimenter (ome::compat::shared_ptr< ome::xml::model::Experimenter > &experimenter)
| Link Experimenter. More...
void | unlinkExperimenter (ome::compat::shared_ptr< ome::xml::model::Experimenter > &experimenter)
| Unlink Experimenter. More...
std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type | sizeOfMicrobeamManipulationList () const
| Get size of linked MicrobeamManipulation list. More...
std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > > & | getMicrobeamManipulationList ()
| Get the MicrobeamManipulation list. More...
const std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > > & | getMicrobeamManipulationList () const
| Get the MicrobeamManipulation list. More...
ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & | getMicrobeamManipulation (std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type index)
| Get MicrobeamManipulation. More...
const ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & | getMicrobeamManipulation (std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type index) const
| Get MicrobeamManipulation. More...
void | setMicrobeamManipulation (std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type index, ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > &microbeamManipulation)
| Set MicrobeamManipulation. More...
void | addMicrobeamManipulation (ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > &microbeamManipulation)
| Add MicrobeamManipulation. More...
void | removeMicrobeamManipulation (ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > &microbeamManipulation)
| Remove MicrobeamManipulation. More...
OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type | sizeOfLinkedImageList () const
| Get size of linked Image list. More...
OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type | getLinkedImageList () const
| Get the linked Image list. More...
const ome::compat::weak_ptr< ome::xml::model::Image > & | getLinkedImage (OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type index) const
| Get linked Image. More...
const ome::compat::weak_ptr< ome::xml::model::Image > & | setLinkedImage (OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type index, const ome::compat::shared_ptr< ome::xml::model::Image > &image_BackReference)
| Set linked Image. More...
bool | linkImage (const ome::compat::shared_ptr< ome::xml::model::Image > &image_BackReference)
| Link Image. More...
bool | unlinkImage (const ome::compat::shared_ptr< ome::xml::model::Image > &image_BackReference)
| Unlink Image. More...
virtual common::xml::dom::Element | asXMLElement (common::xml::dom::Document &document) const
| Transform the object hierarchy rooted at this element to XML. More...
const std::string & | getXMLNamespace () const
| Get the XML namespace for this model object. More...
Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
virtual | ~OMEModelObject ()
| Destructor.
virtual void | update (const common::xml::dom::Element &element,::ome::xml::model::OMEModel &model)
| Update the object hierarchy recursively from an XML DOM tree. More...
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< ::ome::xml::model::OMEModelObject > &object)
| Link a given OME model object to this model object. More...
Public Member Functions inherited from ome::xml::model::OMEModelObject
virtual bool | link (ome::compat::shared_ptr< Reference > &reference, ome::compat::shared_ptr< OMEModelObject > &object)=0
| Link a given OME model object to this model object. More...

## Static Public Member Functions
static ome::compat::shared_ptr< Experiment > | create (const common::xml::dom::Element &element, ome::xml::model::OMEModel &model)
| Create a Experiment model object from DOM element. More...
Static Public Member Functions inherited from ome::xml::model::detail::OMEModelObject
static std::vector< common::xml::dom::Element > | getChildrenByTagName (const common::xml::dom::Element &parent, const std::string &name)
| Retrieve all the children of an element that have a given tag name. More...
static std::string | stripNamespacePrefix (const std::string &value)
| Strip the namespace prefix from a tag name. More...

## Protected Member Functions
virtual common::xml::dom::Element | asXMLElementInternal (common::xml::dom::Document &document, common::xml::dom::Element &element) const
| Transform the object hierarchy rooted at this element to XML. More...
Protected Member Functions inherited from ome::xml::model::detail::OMEModelObject
| OMEModelObject (const std::string &objectType="OMEModelObject")
| Constructor.
| OMEModelObject (const OMEModelObject &copy)
| Copy constructor. More...
template<class C , typename T >
bool | contains (const C &container, const ome::compat::shared_ptr< T > &element)
| Check if a container contains a particular element. More...
Protected Member Functions inherited from ome::xml::model::OMEModelObject
| OMEModelObject ()
| Constructor.

## Private Attributes
ome::compat::shared_ptr< Impl > | impl
| Private implementation details.

## Additional Inherited Members
Protected Attributes inherited from ome::xml::model::detail::OMEModelObject
ome::common::Logger | logger
| Message logger.

## Detailed Description

Experiment model object.

## Constructor & Destructor Documentation

ome::xml::model::Experiment::Experiment | ( | const Experiment & | copy | ) |

Copy constructor.

Parameters

  copy | the Experiment to copy.

## Member Function Documentation

void ome::xml::model::Experiment::addMicrobeamManipulation | ( | ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & | microbeamManipulation | ) |

Add MicrobeamManipulation.

Parameters

  microbeamManipulation | the MicrobeamManipulation to add.

Todo:

  Return list position?

  Detect and handle duplicates?

References impl.

Referenced by update().

Here is the caller graph for this function:

common::xml::dom::Element ome::xml::model::Experiment::asXMLElement | ( | common::xml::dom::Document & | document | ) | const
| virtual

Transform the object hierarchy rooted at this element to XML.

Parameters

  document | document for element creation

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::OMEModelObject.

References asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), and getXMLNamespace().

common::xml::dom::Element ome::xml::model::Experiment::asXMLElementInternal | ( | common::xml::dom::Document & | document,
|  | common::xml::dom::Element & | element
| ) |  | const
| protected virtual

Transform the object hierarchy rooted at this element to XML.

This internal implementation of asXMLelement also requires an XML element, which must not be null, or may be instantiated and passed from superclasses.

Parameters

  document | XML document for element creation.
  element | XML element for setting model data.

Returns
  an XML DOM tree root element for this model object.

Implements ome::xml::model::detail::OMEModelObject.

References ome::common::xml::dom::Node::appendChild(), ome::xml::model::detail::OMEModelObject::asXMLElementInternal(), ome::common::xml::dom::Document::createElementNS(), getXMLNamespace(), impl, and ome::common::xml::dom::Element::setAttribute().

Referenced by asXMLElement().

Here is the caller graph for this function:

ome::compat::shared_ptr< Experiment > ome::xml::model::Experiment::create | ( | const common::xml::dom::Element & | element,
|  | ome::xml::model::OMEModel & | model
| ) |  |
| static

Create a Experiment model object from DOM element.

Parameters

  element | root of the XML DOM tree to from which to construct the model object graph.
  model | handler for the OME model used to track instances and references seen during the update.

Exceptions

  EnumerationException | if there is an error instantiating an enumeration during model object creation, or ModelException if there are any consistency or validity errors found during processing.

Returns
  a new model object.

Referenced by ome::xml::model::OME::update().

Here is the caller graph for this function:

const std::string & ome::xml::model::Experiment::elementName | ( |  | ) | const
| virtual

Get the element name of this model object.

This will be the most-derived class name.

Returns
  the element type.

Implements ome::xml::model::OMEModelObject.

ome::compat::shared_ptr< std::string > ome::xml::model::Experiment::getDescription | ( |  | ) |

Get the Description property.

Returns
  the Description property.

References impl.

const ome::compat::shared_ptr< std::string > ome::xml::model::Experiment::getDescription | ( |  | ) | const

Get the Description property.

Returns
  the Description property.

References impl.

const std::string & ome::xml::model::Experiment::getID | ( |  | ) | const

Get the ID property.

Returns
  the ID property.

References impl.

Referenced by update().

Here is the caller graph for this function:

ome::compat::weak_ptr< ome::xml::model::Experimenter > ome::xml::model::Experiment::getLinkedExperimenter | ( |  | ) |

Get linked Experimenter.

Returns
  the linked Experimenter. The pointer may be null.

References impl.

const ome::compat::weak_ptr< ome::xml::model::Experimenter > ome::xml::model::Experiment::getLinkedExperimenter | ( |  | ) | const

Get linked Experimenter.

Returns
  the linked Experimenter. The pointer may be null.

References impl.

const ome::compat::weak_ptr< ome::xml::model::Image > & ome::xml::model::Experiment::getLinkedImage | ( | OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type | index | ) | const

Get linked Image.

Parameters

  index | the index number of the Image.

Returns
  a weak pointer to the Image.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type ome::xml::model::Experiment::getLinkedImageList | ( |  | ) | const

Get the linked Image list.

Returns
  a reference to the list.

References impl.

ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & ome::xml::model::Experiment::getMicrobeamManipulation | ( | std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type | index | ) |

Get MicrobeamManipulation.

Parameters

  index | the index number of the MicrobeamManipulation.

Returns
  the MicrobeamManipulation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

const ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & ome::xml::model::Experiment::getMicrobeamManipulation | ( | std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type | index | ) | const

Get MicrobeamManipulation.

Parameters

  index | the index number of the MicrobeamManipulation.

Returns
  the MicrobeamManipulation.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > > & ome::xml::model::Experiment::getMicrobeamManipulationList | ( |  | ) |

Get the MicrobeamManipulation list.

Returns
  a reference to the list.

References impl.

const std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > > & ome::xml::model::Experiment::getMicrobeamManipulationList | ( |  | ) | const

Get the MicrobeamManipulation list.

Returns
  a reference to the list.

References impl.

ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > ome::xml::model::Experiment::getType | ( |  | ) |

Get the Type property.

Returns
  the Type property.

References impl.

const ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > ome::xml::model::Experiment::getType | ( |  | ) | const

Get the Type property.

Returns
  the Type property.

References impl.

const std::string & ome::xml::model::Experiment::getXMLNamespace | ( |  | ) | const
| virtual

Get the XML namespace for this model object.

Returns
  the XML namespace.

Implements ome::xml::model::OMEModelObject.

Referenced by asXMLElement(), and asXMLElementInternal().

Here is the caller graph for this function:

bool ome::xml::model::Experiment::link | ( | ome::compat::shared_ptr< Reference > & | reference,
|  | ome::compat::shared_ptr< ome::xml::model::OMEModelObject > & | object
| ) |  |

Link a given OME model object to this model object.

Parameters

  reference | type qualifier for the reference. This should be the corresponding reference type for object. If, for example, object is of type Image, reference must be of type ImageRef.
  object | Model object to link to.

Returns
  `true` if this model object was able to handle the reference, otherwise `false`.

Todo:
  the use of reference to provide type information for the type of object is unconventional and quite possibly unnecessary–a simple string or type_info would suffice for what it's being used for, if it's needed at all. Is this true for all cases? The implementation also needs to do strict checking of the object type; it's not currently failing if it's of the wrong type. This applies to all generated model objects implementing this interface.

Todo:
  This bit is silly; why do we have two dynamic_casts here.

References impl, ome::xml::model::detail::OMEModelObject::link(), ome::xml::model::Experimenter::linkExperiment(), and ome::xml::model::detail::OMEModelObject::logger.

void ome::xml::model::Experiment::linkExperimenter | ( | ome::compat::shared_ptr< ome::xml::model::Experimenter > & | experimenter | ) |

Link Experimenter.

Parameters

  experimenter | the Experimenter to link.

References impl.

bool ome::xml::model::Experiment::linkImage | ( | const ome::compat::shared_ptr< ome::xml::model::Image > & | image_BackReference | ) |

Link Image.

Parameters

  image_BackReference | the Image to link.

Returns
  `true` if the object was added to the internal images list, otherwise `false`.

Todo:
  Why have a return value here; what is it used for? Is this an artifact of the Java API?

References impl.

Referenced by ome::xml::model::Image::link().

Here is the caller graph for this function:

void ome::xml::model::Experiment::removeMicrobeamManipulation | ( | ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & | microbeamManipulation | ) |

Remove MicrobeamManipulation.

Parameters

  microbeamManipulation | the MicrobeamManipulation to remove.

Todo:

  Doesn't the removal break the indexing?

  Does the removal deal with multiple instances; we aren't preventing duplicates on insertion.

References impl.

void ome::xml::model::Experiment::setDescription | ( | ome::compat::shared_ptr< std::string > & | description | ) |

Set the Description property.

Parameters

  description | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

void ome::xml::model::Experiment::setID | ( | const std::string & | id | ) |

Set the ID property.

Parameters

  id | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

const ome::compat::weak_ptr< ome::xml::model::Image > & ome::xml::model::Experiment::setLinkedImage | ( | OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type | index,
|  | const ome::compat::shared_ptr< ome::xml::model::Image > & | image_BackReference
| ) |  |

Set linked Image.

Note
  The index must be valid.

Parameters

  index | the index number of the Image.
  image_BackReference | the Image to set.

Returns
  a weak pointer to the Image.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

void ome::xml::model::Experiment::setMicrobeamManipulation | ( | std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type | index,
|  | ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > & | microbeamManipulation
| ) |  |

Set MicrobeamManipulation.

Parameters

  index | the index number of the MicrobeamManipulation.
  microbeamManipulation | the MicrobeamManipulation to set.

Exceptions

  std::out_of_range | if the index is invalid.

References impl.

void ome::xml::model::Experiment::setType | ( | ome::compat::shared_ptr< ome::xml::model::enums::ExperimentType > & | type | ) |

Set the Type property.

Parameters

  type | the value to set.

References impl.

Referenced by update().

Here is the caller graph for this function:

OMEModelObject::indexed_container< ome::xml::model::Image, ome::compat::weak_ptr >::type::size_type ome::xml::model::Experiment::sizeOfLinkedImageList | ( |  | ) | const

Get size of linked Image list.

Returns
  the size of the list.

References impl.

std::vector< ome::compat::shared_ptr< ome::xml::model::MicrobeamManipulation > >::size_type ome::xml::model::Experiment::sizeOfMicrobeamManipulationList | ( |  | ) | const

Get size of linked MicrobeamManipulation list.

Returns
  the size of the list.

References impl.

void ome::xml::model::Experiment::unlinkExperimenter | ( | ome::compat::shared_ptr< ome::xml::model::Experimenter > & | experimenter | ) |

Unlink Experimenter.

Parameters

  experimenter | the Experimenter to unlink.

Todo:
  This method is fairly pointless since it's equivalent to linking a null pointer. It could call `link(0)` internally.

References impl.

bool ome::xml::model::Experiment::unlinkImage | ( | const ome::compat::shared_ptr< ome::xml::model::Image > & | image_BackReference | ) |

Unlink Image.

Parameters

  image_BackReference | the Image to unlink.

Returns
  `true` if the Image was unlinked, otherwise `false` if the Image was not linked and could hence not be unlinked.

Todo:

  Does the return value serve any useful purpose? Is this also inherited Java API?

  Doesn't the removal break the indexing?

  Does the removal deal with multiple instances; we aren't preventing duplicates on insertion.

References impl.

void ome::xml::model::Experiment::update | ( | const common::xml::dom::Element & | element,
|  | ome::xml::model::OMEModel & | model
| ) |  |
| virtual

Update the object hierarchy recursively from an XML DOM tree.

Note
  No properties are removed, only added or updated.

Parameters

  element | root of the XML DOM tree to from which to construct the model object graph.
  model | handler for the OME model used to track instances and references seen during the update.

Exceptions

  EnumerationException | if there is an error instantiating an enumeration during model object creation, or ModelException if there are any consistency or validity errors found during processing.

Implements ome::xml::model::OMEModelObject.

References addMicrobeamManipulation(), ome::xml::model::OMEModel::addModelObject(), ome::xml::model::OMEModel::addReference(), ome::xml::model::MicrobeamManipulation::create(), ome::common::xml::dom::Element::getAttribute(), ome::xml::model::detail::OMEModelObject::getChildrenByTagName(), getID(), ome::common::xml::dom::Element::getTagName(), ome::common::xml::dom::Element::hasAttribute(), ome::xml::model::detail::OMEModelObject::logger, setDescription(), setID(), setType(), ome::xml::model::detail::OMEModelObject::stripNamespacePrefix(), ome::xml::model::detail::OMEModelObject::update(), and validElementName().

bool ome::xml::model::Experiment::validElementName | ( | const std::string & | name | ) | const
| virtual

Check if a given element name is valid for processing by this model object.

Used for processing nodes when interitance is involved.

Parameters

  name | the element name to check.

Returns
  `true` if valid, `false` if invalid.

Implements ome::xml::model::detail::OMEModelObject.

References ome::xml::model::detail::OMEModelObject::validElementName().

Referenced by update().

Here is the caller graph for this function:

The documentation for this class was generated from the following files:

- ome/xml/model/Experiment.h
- ome/xml/model/Experiment.cpp